unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls,
  WEBLib.ExtCtrls, Vcl.Imaging.jpeg, Vcl.Graphics, Vcl.Imaging.pngimage;

type
  TForm1 = class(TWebForm)
    Img_Example: TWebImageControl;
    Lbl_ExplainImage: TWebLabel;
    PB_Example: TWebPaintBox;
      Btn_Copy: TWebButton;
    PB_PixelCopy2: TWebPaintBox;
    Btn_PixelCopy2: TWebButton;
    PB_PixelCopy1: TWebPaintBox;
    Btn_PixelCopy1: TWebButton;
    WebLabel1: TWebLabel;
    procedure Btn_CopyClick(Sender: TObject);
    procedure PB_ExamplePaint(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
    procedure Btn_PixelCopy1Click(Sender: TObject);
    procedure Btn_PixelCopy2Click(Sender: TObject);
  private
    { Private declarations }
    v_Graphic: TGraphic;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  System.Types;

procedure TForm1.WebFormCreate(Sender: TObject);
begin { TForm1.WebFormCreate }
  v_Graphic := nil;
  Btn_PixelCopy1.Enabled := False;
  Btn_PixelCopy2.Enabled := False;
end { TForm1.WebFormCreate };

procedure TForm1.Btn_CopyClick(Sender: TObject);
begin { TForm1.Btn_CopyClick }
  if v_Graphic = nil
  then
    begin
      v_Graphic := TGraphic.Create;
      v_Graphic.LoadFromURL('data:image/png;base64,' + Img_Example.Base64Image,
                            procedure
                            begin
                              Btn_PixelCopy1.Enabled := True;
                              Btn_PixelCopy2.Enabled := True;
                              PB_ExamplePaint(PB_Example)
                            end)
    end;
end { TForm1.Btn_CopyClick };

procedure TForm1.PB_ExamplePaint(Sender: TObject);
begin { TForm1.PB_ExamplePaint }
  if v_Graphic <> nil
  then
    begin
      PB_Example.Canvas.Brush.Style := bsClear;
      PB_Example.Canvas.Draw(0, 0, v_Graphic)
    end
end { TForm1.PB_ExamplePaint };

procedure TForm1.Btn_PixelCopy1Click(Sender: TObject);
var
                  R: Byte;
                  G: Byte;
                  B: Byte;
                  i: Integer;
                  j: Integer;
             RGBInt: Integer;
           OneColor: TColor;
          TheBitmap: TBitmap;
begin { Btn_PixelCopy1Click }
  if v_Graphic <> nil
  then
    begin
      TheBitmap := TBitmap.Create;
      TheBitmap.SetSize(v_Graphic.Width, v_Graphic.Height);
      TheBitmap.Canvas.Draw(0, 0, v_Graphic);
      for i := 0 to v_Graphic.Width - 1 do
        for j := 0 to v_Graphic.Height - 1 do
          begin
            OneColor := TheBitmap.Canvas.Pixels [i, j];
            RGBInt := ColorToRGB(OneColor);
            R := GetRValue(RGBInt);
            G := GetGValue(RGBInt);
            B := GetBValue(RGBInt);
            TheBitmap.Canvas.Pixels [i, j] := RGB(R, G, B)
          end;
      PB_PixelCopy1.Canvas.Draw(0, 0, TheBitmap);
    end
end { Btn_PixelCopy1Click };

procedure TForm1.Btn_PixelCopy2Click(Sender: TObject);
var
                  R: Byte;
                  G: Byte;
                  B: Byte;
                  i: Integer;
                  j: Integer;
             RGBInt: Integer;
           OneColor: TColor;
          TheBitmap: TBitmap;
begin { TForm1.Btn_PixelCopy2Click }
  if v_Graphic <> nil
  then
    begin
      TheBitmap := TBitmap.Create;
      TheBitmap.SetSize(v_Graphic.Width, v_Graphic.Height);
      for i := 0 to v_Graphic.Width - 1 do
        for j := 0 to v_Graphic.Height - 1 do
          begin
            OneColor := v_Graphic.Canvas.Pixels [i, j] { = ALWAYS 0 };
            RGBInt := ColorToRGB(OneColor);
            R := GetRValue(RGBInt);
            G := GetGValue(RGBInt);
            B := GetBValue(RGBInt);
            TheBitmap.Canvas.Pixels [i, j] := RGB(R, G, B)
          end;
      PB_PixelCopy2.Canvas.Draw(0, 0, TheBitmap);
    end
end { TForm1.Btn_PixelCopy2Click };

end.
